test group_commit is unstable

Bug #1608515 reported by Laurynas Biveinis on 2016-08-01
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Percona Server moved to https://jira.percona.com/projects/PS
Status tracked in 5.7
5.5
Fix Released
Low
Laurynas Biveinis
5.6
Invalid
Undecided
Unassigned
5.7
Invalid
Undecided
Unassigned

Bug Description

Test group_commit in 5.5 may fail as follows:

main.group_commit w1 [ fail ]
        Test ended at 2016-07-29 03:44:42

CURRENT_TEST: main.group_commit
--- /mnt/workspace/percona-server-5.5-param/BUILD_TYPE/debug/Host/centos6-32/mysql-test/r/group_commit.result 2016-07-26 13:01:50.064932306 +0300
+++ /mnt/workspace/percona-server-5.5-param/BUILD_TYPE/debug/Host/centos6-32/mysql-test/r/group_commit.reject 2016-07-29 10:44:42.027694151 +0300
@@ -28,20 +28,32 @@
 SET DEBUG_SYNC= "commit_after_get_LOCK_log SIGNAL con5_leader WAIT_FOR con6_queued";
 INSERT INTO t1 VALUES ("con5");
 SET DEBUG_SYNC= "now WAIT_FOR con5_leader";
+Warnings:
+Warning 1639 debug sync point wait timed out
 SET DEBUG_SYNC= "commit_group_commit_queue SIGNAL con6_queued";
 INSERT INTO t1 VALUES ("con6");
 SET DEBUG_SYNC= "now WAIT_FOR group3_con5";
+Warnings:
+Warning 1639 debug sync point wait timed out
 SELECT * FROM t1 ORDER BY a;
 a
 con1
+con2
+con3
+con4
+con5
 SET DEBUG_SYNC= "now SIGNAL group3_committed";
 SET DEBUG_SYNC= "now WAIT_FOR group2_visible";
+Warnings:
+Warning 1639 debug sync point wait timed out
 SELECT * FROM t1 ORDER BY a;
 a
 con1
 con2
 con3
 con4
+con5
+con6
 SET DEBUG_SYNC= "now SIGNAL group2_checked";
 SELECT * FROM t1 ORDER BY a;
 a

mysqltest: Result content mismatch

This failure is consistent with con5 transaction committing in the previous commit group instead of leading its own group. Such issue has been fixed in MariaDB 5.3, and its fix should be ported:

    revno: 2732.26.19
    committer: <email address hidden>
    branch nick: work-5.2-rpl
    timestamp: Thu 2011-04-14 13:23:02 +0200
    message:
      Fix race in testcase innodb_plugin.group_commit

      The problem was that connection con5, which is supposed to be the leader for
      the third group, could if timing was bad end up as participant in the second
      group, causing the test to fail.

      Fixed by ensuring that group 2 is running before starting the transaction
      for group 3.

tags: added: ci upstream

Percona now uses JIRA for bug reports so this bug report is migrated to: https://jira.percona.com/browse/PS-3504

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers